-- C:\CIRCUIT\PROTOTYPE\XDN001\CFG_TOP\CFG_SEL_WAVE.VHW
-- VHDL Test Bench created by
-- HDL Bencher 2.01
-- Tue Apr 02 11:39:54 2002
-- 
-- Notes:
-- 1) This testbench has been automatically generated from
--   your Test Bench Waveform
-- 2) To use this as a user modifiable testbench do the following:
--   - Save it as a file with a .vhd extension (i.e. File->Save As...)
--   - Add it to your project as a testbench source (i.e. Project->Add Source...)
-- 

LIBRARY  IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 87
FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";
	COMPONENT CFG_SELECTOR
		PORT (
			CLK : in  std_logic;
			RST : in  std_logic;
			SWITCH : in  std_logic;
			MSEC : in  std_logic;
			CFG_ENB : out  std_logic
		);
	END COMPONENT;

	SIGNAL CLK : std_logic;
	SIGNAL RST : std_logic;
	SIGNAL SWITCH : std_logic;
	SIGNAL MSEC : std_logic;
	SIGNAL CFG_ENB : std_logic;

BEGIN
	UUT : CFG_SELECTOR
	PORT MAP (
		CLK => CLK,
		RST => RST,
		SWITCH => SWITCH,
		MSEC => MSEC,
		CFG_ENB => CFG_ENB
	);

	PROCESS -- clock process
	BEGIN
		CLOCK_LOOP : LOOP
		CLK <= transport '0';
		WAIT FOR 1 ns;
		CLK <= transport '1';
		WAIT FOR 1 ns;
		WAIT FOR 2 ns;
		CLK <= transport '0';
		WAIT FOR 2 ns;
		END LOOP CLOCK_LOOP;
	END PROCESS;

	PROCESS
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_CFG_ENB(
			next_CFG_ENB : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (CFG_ENB /= next_CFG_ENB) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns CFG_ENB="));
				write(TX_LOC, CFG_ENB);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_CFG_ENB);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		RST <= transport '1';
		SWITCH <= transport '0';
		MSEC <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=6 ns
		RST <= transport '0';
		-- --------------------
		WAIT FOR 12 ns; -- Time=18 ns
		SWITCH <= transport '1';
		MSEC <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=24 ns
		MSEC <= transport '0';
		-- --------------------
		WAIT FOR 12 ns; -- Time=36 ns
		MSEC <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=42 ns
		SWITCH <= transport '1';
		MSEC <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=48 ns
		SWITCH <= transport '0';
		-- --------------------
		WAIT FOR 12 ns; -- Time=60 ns
		SWITCH <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=66 ns
		MSEC <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=72 ns
		MSEC <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=78 ns
		SWITCH <= transport '0';
		-- --------------------
		WAIT FOR 36 ns; -- Time=114 ns
		SWITCH <= transport '1';
		-- --------------------
		WAIT FOR 12 ns; -- Time=126 ns
		MSEC <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=132 ns
		MSEC <= transport '0';
		-- --------------------
		WAIT FOR 6 ns; -- Time=138 ns
		SWITCH <= transport '0';
		-- --------------------
		WAIT FOR 12 ns; -- Time=150 ns
		MSEC <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=156 ns
		MSEC <= transport '0';
		-- --------------------
		WAIT FOR 24 ns; -- Time=180 ns
		SWITCH <= transport '1';
		MSEC <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=186 ns
		MSEC <= transport '0';
		-- --------------------
		WAIT FOR 12 ns; -- Time=198 ns
		MSEC <= transport '1';
		-- --------------------
		WAIT FOR 6 ns; -- Time=204 ns
		MSEC <= transport '0';
		-- --------------------
		WAIT FOR 12 ns; -- Time=216 ns
		SWITCH <= transport '0';
		-- --------------------
		WAIT FOR 2998 ns; -- Time=3214 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION CFG_SELECTOR_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END CFG_SELECTOR_cfg;
